import { system, Vector, world} from "@minecraft/server";
import { getScore } from "../functions";
import { ActionFormData, MessageFormData, ModalFormData } from "@minecraft/server-ui";
system.events.scriptEventReceive.subscribe(data => {
   if(data.id == "blayy:furnace") {
     const entity = data.sourceEntity
   const inv = entity.getComponent("inventory").container
   let item = inv.getItem(0)
 if (item) {
   if (item.typeId.includes("cooked") == false) {
   entity.runCommandAsync(`replaceitem entity @s slot.inventory 0 ${item.typeId.split(":")[0]}:cooked_${item.typeId.split(":")[1]} ${item.amount}`)
   }
   if (item.typeId.includes("raw") == true) {
     entity.runCommandAsync(`replaceitem entity @s slot.inventory 0 ${item.typeId.replace('raw_', '')}_ingot ${item.amount}`)
 }
 }
 
    }
    if (data.id == "blayy:add_energy") {
      const entity = data.sourceEntity
      const tag = entity.getTags();
 entity.runCommandAsync(`function thermal_on`)
entity.runCommandAsync(`scoreboard players add @e[type=blayy:energy_cube,tag=${tag[0]}] energy 1`)
    }
    if (data.id == "blayy:tpent") {
      const entity = data.sourceEntity
      const reach = getScore("reach", entity)
      const tag = entity.getTags();
      entity.runCommandAsync(`tp @e[type=item,r=${reach},name="${tag[0]}"] @s`) 
      entity.runCommandAsync(`tp @e[type=item,r=${reach},name="${tag[1]}"] @s`)
      entity.runCommandAsync(`tp @e[type=item,r=${reach},name="${tag[2]}"] @s`)
      entity.runCommandAsync(`tp @e[type=item,r=${reach},name="${tag[3]}"] @s`)
      entity.runCommandAsync(`tp @e[type=item,r=${reach},name="${tag[4]}"] @s`)
    }
    if (data.id == "blayy:ore_converter") {
  const block = data.sourceBlock
 const x = block.location.x
 const y = block.location.y
 const z = block.location.z
 const overworld = world.getDimension("overworld")
 const location = new Vector(x, y+1, z)
 const block1 = overworld.getBlock(location)
 if (block1.typeId.includes('ore') == true) {
let id = block1.typeId.split(":")[0] 
let bloquin = block1.typeId.split(":")[1]
let bloca = bloquin.replace('ore', 'block')
let bloco2 = bloca.replace('deepslate_', '')
let bloco1 = bloco2.replace('netherrack_', '')
let bloco0 = bloco1.replace('end_', '')
let bloco = bloco0.replace('nether_', '')
overworld.runCommandAsync(`execute if block ${x} ${y+1} ${z} ${block1.typeId} run setblock ${x} ${y+1} ${z} ${id}:${bloco}`)
overworld.runCommandAsync(`execute if block ${x} ${y+1} ${z} ${id}:${bloco} run setblock ${x} ${y+1} ${z} air [] destroy`)
 }
}
if (data.id == "blayy:uibb") {
  const block = data.sourceBlock
  const x = block.location.x
  const y = block.location.y
  const z = block.location.z
  const teste = new Vector(x, y, z)
  const overworld = world.getDimension("overworld")
const entities = overworld.getEntitiesAtBlockLocation(teste) 
for (const entity of entities) {
  
  const query = {
  tags: [`drawer_open`],
  };
  const players = world.getPlayers(query);
  for (const player of players) {
    const itemdata = player.getComponent("inventory").container.getItem(player.selectedSlot)
    player.removeTag("drawer_open")
  if (entity.typeId == "blayy:entity_drawer") {
     
  let entitytags = entity.getTags()
  if (entitytags == "") {
    if (itemdata.typeId) {
      
     const conff = new MessageFormData()
    conff.title({ translate: "drawer.digital_drawer" })
    conff.body({ translate: "conff.text" })
    conff.button1({ translate: "text.cancel" })
    conff.button2({ translate: "text.confirm" })
    conff.show(player).then(response => {
      if (response.selection == 1) {
    player.runCommandAsync(`title @p title §bDrawer Set To\n${itemdata.typeId}`)
    entity.runCommandAsync(`tag @s add "${itemdata.typeId}"`)
    entity.runCommandAsync(`tag @s add nopass`)
      }
    })
      
    }
  }
if (entitytags[1] == "nopass") {
  const score = getScore("storage", entity)
  const scoremax = getScore("max_storage", entity)
  
    const drawer = new ActionFormData()
      drawer.title(`drawer.digital_drawer`)
      drawer.body(`Item: ${entitytags[0]}\n${score}/${scoremax}`)
      drawer.button(`drawer.get`, "textures/ui/touch_glyph_color")
      drawer.button(`drawer.input`, "textures/ui/share_apple")
      drawer.button(`drawer.addpass`, "textures/items/security_padlock")
      drawer.show(player).then(response => {
        if (response.selection == 0) {
          
          const get1 = new ModalFormData()
          get1.title(`get1.getitems`)
          get1.textField(`Amount\n${entitytags[0]}\n${score}/${scoremax}`, `escreva.quantity`, "")
          get1.show(player).then(item => {
            if (item.formValues[0] <= score) {
              player.runCommandAsync(`give @s ${entitytags[0]} ${item.formValues[0]} 0`)
              entity.runCommandAsync(`scoreboard players remove @s storage ${item.formValues[0]}`)
            }
          })
         
        }
        if (response.selection == 1) {
          
          const input = new ModalFormData()
          input.title(`drawer.input`)
          input.textField(`field.quant`, `escreva.quantity`, "")
          input.show(player).then(items => {
            let soma = (Number(items.formValues[0]) + score)
          if (soma <= scoremax) {
            
            entity.runCommandAsync(`execute if entity @p[name=${player.nameTag},hasitem={item=${entitytags[0]},quantity=${items.formValues[0]}..}] run scoreboard players add @s storage ${items.formValues[0]}`)
              player.runCommandAsync(`clear @s[hasitem={item=${entitytags[0]},quantity=${items.formValues[0]}..}] ${entitytags[0]} 0 ${items.formValues[0]}`)
            }
          })
         
        }
        if (response.selection == 2) {
          
          const pass = new ModalFormData()
          pass.title("pass.create")
          pass.textField(`pass.password`, `escreva.aqui`, "")
          pass.show(player).then(password => {
            if (password.formValues[0] != "") {
              entity.runCommandAsync(`tag @s remove nopass`)
              entity.runCommandAsync(`tag @s add "pass_${password.formValues[0]}"`)
            }
          })
          
        }
      })
  
    }else{
      
     const passui = new ModalFormData()
     if (entitytags != "") {
     passui.title(`pass.password1`)
     passui.textField(`pass.password`, `escreva.aqui`, "")
      }else{
        passui.title(`Item Set!!`)
        passui.toggle(entitytags[0], true)
      }
     passui.show(player).then(response => {
     
       if (response.formValues[0] == entitytags[1].replace('pass_', '')) {
         const score = getScore("storage", entity)
  const scoremax = getScore("max_storage", entity)
  
    const drawer = new ActionFormData()
      drawer.title(`drawer.digital_drawer`)
      drawer.body(`Item: ${entitytags[0]}\n${score}/${scoremax}\nPassword: ${entitytags[1].replace('pass_', '')}`)
      drawer.button(`drawer.get`, "textures/ui/touch_glyph_color")
      drawer.button(`drawer.input`, "textures/ui/share_apple")
      drawer.button(`drawer.changepass`, "textures/items/security_padlock")
      drawer.show(player).then(response => {
        if (response.selection == 0) {
          
          const get1 = new ModalFormData()
          get1.title("get1.getitems")
          get1.textField(`${entitytags[0]}\n${score}/${scoremax}`, `escreva.quantity`, "")
          get1.show(player).then(item => {
            if (item.formValues[0] <= score) {
              player.runCommandAsync(`give @s ${entitytags[0]} ${item.formValues[0]} 0`)
              entity.runCommandAsync(`scoreboard players remove @s storage ${item.formValues[0]}`)
            }
          })
         
        }
        if (response.selection == 1) {
          const input = new ModalFormData()
          input.title(`drawer.input`)
          input.textField(``, `escreva.quantity`, "")
          input.show(player).then(items => {
            let soma = (Number(items.formValues[0]) + score)
          if (soma <= scoremax) {
            entity.runCommandAsync(`execute if entity @p[name=${player.nameTag},hasitem={item=${entitytags[0]},quantity=${items.formValues[0]}..}] run scoreboard players add @s storage ${items.formValues[0]}`)
              player.runCommandAsync(`clear @s[hasitem={item=${entitytags[0]},quantity=${items.formValues[0]}..}] ${entitytags[0]} 0 ${items.formValues[0]}`)
            }
          })
        }
        if (response.selection == 2) {
           
          const pass = new ModalFormData()
          pass.title("drawer.changepass")
          pass.textField(`drawer.newpass`, `escreva.aqui`, "")
          pass.show(player).then(password => {
            if (password.formValues[0] != "") {
              entity.runCommandAsync(`tag @s remove ${entitytags[1]}`)
              entity.runCommandAsync(`tag @s add "pass_${password.formValues[0]}"`)
            }
          })
         
        }
      })//oi
  
       }
     })
      
    }
  
    //aqui final
 }//oi
 if (entity.typeId == "blayy:tp_entity") {
  
    let tags = entity.getTags()
    
    const tp = new ActionFormData()
    const reach = getScore("reach", entity)
    tp.title(`tile.blayy:item_teleporter.name`)
    tp.body(`${tags}\nR: ${reach}`)
    tp.button(`tp.include`, "textures/ui/icon_recipe_equipment")
    tp.button(`tp.reach`, "textures/ui/icon_expand")
    tp.show(player).then(response => {
      if (response.selection == 0) {
      
        const tpmodal = new ModalFormData()
        tpmodal.title(`tile.blayy:item_teleporter.name`)
        tpmodal.textField(`text.name`, `escreva.aqui`, "")
        tpmodal.show(player).then(cuu => {
          if (cuu.formValues[0] != "") {
        entity.runCommandAsync(`tag @s add "${cuu.formValues[0]}"`)
          }else{
       player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"erro.field"}]}`)
     }
        })
      
      }


      if (response.selection == 1) {
        
        const parede = new ModalFormData()
        parede.title(`tile.blayy:item_teleporter.name`)
        parede.slider(``, 2, 20, 1)
        parede.show(player).then(seila => {
          entity.runCommandAsync(`scoreboard players set @s reach ${seila.formValues}`)
        })
       
      }
    })
  

}
}
}

}
})